package pp.s1184725.boppi.test;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.nio.charset.StandardCharsets;
import java.util.List;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import org.antlr.v4.runtime.ParserRuleContext;
import org.apache.commons.lang3.tuple.Pair;
import org.junit.Test;

import pp.iloc.Simulator;
import pp.s1184725.boppi.Annotations;
import pp.s1184725.boppi.BasicParser;
import pp.s1184725.boppi.BasicParserHelper;
import pp.s1184725.boppi.BoppiBasicChecker;
import pp.s1184725.boppi.BoppiBasicGenerator;

public class GeneratorTest {
	static private List<LogRecord> generateAndGetLog(String code) {
		Logger logger = Logger.getAnonymousLogger();
		Pair<BasicParser, List<LogRecord>> pair = BasicParserHelper.getParserWithLog(code, logger);
		Annotations annotater = new Annotations();
		ParserRuleContext tree = pair.getLeft().program();
		new BoppiBasicChecker(logger, annotater).visit(tree);
		BoppiBasicGenerator generator = new BoppiBasicGenerator(annotater);
		generator.visit(tree);
//		System.out.println(generator.prog.prettyPrint());
//		System.out.println(BasicParserHelper.getAnnotatedDOT(tree, annotater));
		Simulator s = new Simulator(generator.prog);
		InputStream in = new ByteArrayInputStream("1\nq\n".getBytes(StandardCharsets.UTF_8));
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		s.setIn(in);
		s.setOut(out);
		s.run();
		System.out.println(out.toString());
		return pair.getRight();
	}
	
	@Test
	public void basicTest() {
//		generateAndGetLog("print(5*3)");
//		generateAndGetLog("var int x; var int y; x := 3*(y := 4); print(x,y)");
//		generateAndGetLog("print('T', 'e', 's', 't', '!')");
//		generateAndGetLog("var int i; if read(i) == 1 then var char c; read(c); print(c,c); else print(i) fi");
		generateAndGetLog("var int i; i := 10; while i > 0 do print('A', i); i := i-1 od");
	}
}
